org.python.core

## Class AstList

- java.lang.Object
- - org.python.core.PyObject
  - - org.python.core.PySequence
    - - org.python.core.AstList

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable, java.lang.Iterable, java.util.Collection, java.util.List, Traverseproc

    public class AstList
    extends PySequence
    implements java.lang.Cloneable, java.util.List, Traverseproc

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class org.python.core.PyObject

`PyObject.ConversionException`

### Field Summary

Fields
`static PyType` `TYPE`

### Fields inherited from class org.python.core.PyObject

`gcMonitorGlobal`

### Constructor Summary

Constructors
Constructor and Description
`AstList()`
`AstList(java.util.List data)`
`AstList(java.util.List data, org.python.antlr.adapter.AstAdapter adapter)`
`AstList(PyType type, java.util.List data, org.python.antlr.adapter.AstAdapter adapter)`

### Method Summary

All Methods Instance Methods Concrete Methods
`PyObject` `__add__(PyObject other)` Equivalent to the standard Python __add__ method.
`PyObject` `__iadd__(PyObject other)` Equivalent to the standard Python __iadd__ method.
`PyObject` `__imul__(PyObject o)` Equivalent to the standard Python __imul__ method.
`int` `__len__()` Equivalent to the standard Python __len__ method.
`PyObject` `__mul__(PyObject o)` Equivalent to the standard Python __mul__ method.
`PyObject` `__radd__(PyObject o)` Equivalent to the standard Python __radd__ method.
`PyObject` `__rmul__(PyObject o)` Equivalent to the standard Python __rmul__ method.
`java.lang.Object` `__tojava__(java.lang.Class c)` Equivalent to the Jython __tojava__ method.
`void` `add(int index, java.lang.Object element)`
`boolean` `add(java.lang.Object o)`
`boolean` `addAll(java.util.Collection c)`
`boolean` `addAll(int index, java.util.Collection c)`
`void` `append(PyObject o)`
`PyObject` `astlist___iter__()`
`void` `clear()`
`java.lang.Object` `clone()`
`boolean` `contains(java.lang.Object o)`
`boolean` `containsAll(java.util.Collection c)`
`int` `count(PyObject value)`
`void` `extend(PyObject iterable)`
`PyString[]` `get_fields()`
`java.lang.Object` `get(int index)`
`int` `index(PyObject o)`
`int` `index(PyObject o, int start)`
`int` `index(PyObject o, int start, int stop)`
`int` `indexOf(java.lang.Object o)`
`void` `insert(int index, PyObject o)`
`boolean` `isEmpty()`
`java.util.Iterator` `iterator()`
`int` `lastIndexOf(java.lang.Object o)`
`java.util.ListIterator` `listIterator()`
`java.util.ListIterator` `listIterator(int index)`
`PyObject` `pop()`
`PyObject` `pop(int n)`
`void` `pyadd(int index, PyObject element)`
`boolean` `pyadd(PyObject o)`
`PyObject` `pyget(int index)` Returns the element of the sequence at the given index.
`void` `pyset(int index, PyObject element)` Sets the indexed element of the sequence to the given value.
`boolean` `refersDirectlyTo(PyObject ob)` Optional operation.
`java.lang.Object` `remove(int index)`
`boolean` `remove(java.lang.Object o)`
`void` `remove(PyObject value)`
`boolean` `removeAll(java.util.Collection c)`
`boolean` `retainAll(java.util.Collection c)`
`void` `reverse()`
`java.lang.Object` `set(int index, java.lang.Object element)`
`int` `size()`
`java.util.List` `subList(int fromIndex, int toIndex)`
`java.lang.Object[]` `toArray()`
`java.lang.Object[]` `toArray(java.lang.Object[] a)`
`java.lang.String` `toString()`
`int` `traverse(Visitproc visit, java.lang.Object arg)` Traverses all directly contained `PyObject`s.

### Methods inherited from class org.python.core.PySequence

`__delitem__, __delslice__, __eq__, __finditem__, __finditem__, __ge__, __getitem__, __getslice__, __gt__, __iter__, __le__, __lt__, __ne__, __nonzero__, __setitem__, __setitem__, __setslice__, isMappingType, isNumberType, isSequenceType`

### Methods inherited from class org.python.core.PyObject

`__abs__, __and__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __cmp__, __coerce__, __coerce_ex__, __complex__, __contains__, __delattr__, __delattr__, __delete__, __delitem__, __delslice__, __dir__, __div__, __divmod__, __ensure_finalizer__, __findattr__, __findattr__, __findattr_ex__, __finditem__, __float__, __floordiv__, __format__, __get__, __getattr__, __getattr__, __getitem__, __getnewargs__, __getslice__, __hash__, __hex__, __iand__, __idiv__, __idivmod__, __ifloordiv__, __ilshift__, __imod__, __index__, __int__, __invert__, __ior__, __ipow__, __irshift__, __isub__, __iternext__, __itruediv__, __ixor__, __long__, __lshift__, __mod__, __neg__, __not__, __oct__, __or__, __pos__, __pow__, __pow__, __rand__, __rdiv__, __rdivmod__, __reduce__, __reduce_ex__, __reduce_ex__, __repr__, __rfloordiv__, __rlshift__, __rmod__, __ror__, __rpow__, __rrshift__, __rshift__, __rsub__, __rtruediv__, __rxor__, __set__, __setattr__, __setattr__, __setitem__, __setslice__, __str__, __sub__, __truediv__, __trunc__, __unicode__, __xor__, _add, _and, _callextra, _cmp, _div, _divmod, _doget, _doget, _doset, _eq, _floordiv, _ge, _gt, _iadd, _iand, _idiv, _idivmod, _ifloordiv, _ilshift, _imod, _imul, _in, _ior, _ipow, _irshift, _is, _isnot, _isub, _itruediv, _ixor, _jcall, _jcallexc, _jthrow, _le, _lshift, _lt, _mod, _mul, _ne, _notin, _or, _pow, _rshift, _sub, _truediv, _xor, asDouble, asIndex, asIndex, asInt, asInt, asIterable, asLong, asLong, asName, asName, asString, asString, asStringOrNull, asStringOrNull, bit_length, conjugate, delDict, delType, dispatch__init__, equals, fastGetClass, fastGetDict, getDict, getType, hashCode, implementsDescrDelete, implementsDescrGet, implementsDescrSet, invoke, invoke, invoke, invoke, invoke, invoke, isCallable, isDataDescr, isIndex, isInteger, noAttributeError, object___subclasshook__, readonlyAttributeError, setDict, setType`

### Methods inherited from class java.lang.Object

`equals, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.util.List

`equals, hashCode, replaceAll, sort, spliterator`

### Methods inherited from interface java.util.Collection

`parallelStream, removeIf, stream`

### Methods inherited from interface java.lang.Iterable

`forEach`

### Field Detail

#### TYPE

    public static final PyType TYPE

### Constructor Detail

#### AstList

    public AstList()

#### AstList

    public AstList(java.util.List data)

#### AstList

    public AstList(java.util.List data,
                   org.python.antlr.adapter.AstAdapter adapter)

#### AstList

    public AstList(PyType type,
                   java.util.List data,
                   org.python.antlr.adapter.AstAdapter adapter)

### Method Detail

#### get_fields

    public PyString[] get_fields()

#### astlist___iter__

    public PyObject astlist___iter__()

#### __imul__

    public PyObject __imul__(PyObject o)

Description copied from class: `PyObject`
Equivalent to the standard Python __imul__ method.

Overrides:
  `__imul__` in class `PyObject`
Parameters:
  `o` - the object to perform this binary operation with (the right-hand operand).
Returns:
  the result of the imul, or null if this operation is not defined.

#### __mul__

    public PyObject __mul__(PyObject o)

Description copied from class: `PyObject`
Equivalent to the standard Python __mul__ method.

Overrides:
  `__mul__` in class `PyObject`
Parameters:
  `o` - the object to perform this binary operation with (the right-hand operand).
Returns:
  the result of the mul, or null if this operation is not defined

#### __rmul__

    public PyObject __rmul__(PyObject o)

Description copied from class: `PyObject`
Equivalent to the standard Python __rmul__ method.

Overrides:
  `__rmul__` in class `PyObject`
Parameters:
  `o` - the object to perform this binary operation with (the left-hand operand).
Returns:
  the result of the mul, or null if this operation is not defined.

#### __iadd__

    public PyObject __iadd__(PyObject other)

Description copied from class: `PyObject`
Equivalent to the standard Python __iadd__ method.

Overrides:
  `__iadd__` in class `PyObject`
Parameters:
  `other` - the object to perform this binary operation with (the right-hand operand).
Returns:
  the result of the iadd, or null if this operation is not defined

#### __add__

    public PyObject __add__(PyObject other)

Description copied from class: `PyObject`
Equivalent to the standard Python __add__ method.

Overrides:
  `__add__` in class `PyObject`
Parameters:
  `other` - the object to perform this binary operation with (the right-hand operand).
Returns:
  the result of the add, or null if this operation is not defined.

#### __radd__

    public PyObject __radd__(PyObject o)

Description copied from class: `PyObject`
Equivalent to the standard Python __radd__ method.

Overrides:
  `__radd__` in class `PyObject`
Parameters:
  `o` - the object to perform this binary operation with (the left-hand operand).
Returns:
  the result of the add, or null if this operation is not defined.

#### __len__

    public int __len__()

Description copied from class: `PyObject`
Equivalent to the standard Python __len__ method. Part of the mapping discipline.

Overrides:
  `__len__` in class `PyObject`
Returns:
  the length of the object

#### toString

    public java.lang.String toString()

Overrides:
  `toString` in class `PyObject`

#### append

    public void append(PyObject o)

#### clone

    public java.lang.Object clone()

Overrides:
  `clone` in class `java.lang.Object`

#### count

    public int count(PyObject value)

#### index

    public int index(PyObject o)

#### index

    public int index(PyObject o,
                     int start)

#### index

    public int index(PyObject o,
                     int start,
                     int stop)

#### extend

    public void extend(PyObject iterable)

#### insert

    public void insert(int index,
                       PyObject o)

#### remove

    public void remove(PyObject value)

#### reverse

    public void reverse()

#### pop

    public PyObject pop()

#### pop

    public PyObject pop(int n)

#### add

    public void add(int index,
                    java.lang.Object element)

Specified by:
  `add` in interface `java.util.List`

#### add

    public boolean add(java.lang.Object o)

Specified by:
  `add` in interface `java.util.Collection`
Specified by:
  `add` in interface `java.util.List`

#### addAll

    public boolean addAll(int index,
                          java.util.Collection c)

Specified by:
  `addAll` in interface `java.util.List`

#### addAll

    public boolean addAll(java.util.Collection c)

Specified by:
  `addAll` in interface `java.util.Collection`
Specified by:
  `addAll` in interface `java.util.List`

#### clear

    public void clear()

Specified by:
  `clear` in interface `java.util.Collection`
Specified by:
  `clear` in interface `java.util.List`

#### contains

    public boolean contains(java.lang.Object o)

Specified by:
  `contains` in interface `java.util.Collection`
Specified by:
  `contains` in interface `java.util.List`

#### containsAll

    public boolean containsAll(java.util.Collection c)

Specified by:
  `containsAll` in interface `java.util.Collection`
Specified by:
  `containsAll` in interface `java.util.List`

#### get

    public java.lang.Object get(int index)

Specified by:
  `get` in interface `java.util.List`

#### indexOf

    public int indexOf(java.lang.Object o)

Specified by:
  `indexOf` in interface `java.util.List`

#### isEmpty

    public boolean isEmpty()

Specified by:
  `isEmpty` in interface `java.util.Collection`
Specified by:
  `isEmpty` in interface `java.util.List`

#### iterator

    public java.util.Iterator iterator()

Specified by:
  `iterator` in interface `java.lang.Iterable`
Specified by:
  `iterator` in interface `java.util.Collection`
Specified by:
  `iterator` in interface `java.util.List`

#### lastIndexOf

    public int lastIndexOf(java.lang.Object o)

Specified by:
  `lastIndexOf` in interface `java.util.List`

#### listIterator

    public java.util.ListIterator listIterator()

Specified by:
  `listIterator` in interface `java.util.List`

#### listIterator

    public java.util.ListIterator listIterator(int index)

Specified by:
  `listIterator` in interface `java.util.List`

#### pyadd

    public boolean pyadd(PyObject o)

#### pyadd

    public void pyadd(int index,
                      PyObject element)

#### pyget

    public PyObject pyget(int index)

Description copied from class: `PySequence`
Returns the element of the sequence at the given index. This is an extension point called by PySequence in its implementation of `PySequence.__getitem__(org.python.core.PyObject)` It is guaranteed by PySequence that when it calls `pyget(int)` the index is within the bounds of the array. Any other clients must make the same guarantee.

Parameters:
  `index` - index of element to return.
Returns:
  the element at the given position in the list.

#### pyset

    public void pyset(int index,
                      PyObject element)

Description copied from class: `PySequence`
Sets the indexed element of the sequence to the given value. This is an extension point called by PySequence in its implementation of `PySequence.__setitem__(int, org.python.core.PyObject)` It is guaranteed by PySequence that when it calls pyset(int) the index is within the bounds of the array. Any other clients must make the same guarantee.

Parameters:
  `index` - index of the element to set.
  `element` - the value to set this element to.

#### remove

    public java.lang.Object remove(int index)

Specified by:
  `remove` in interface `java.util.List`

#### remove

    public boolean remove(java.lang.Object o)

Specified by:
  `remove` in interface `java.util.Collection`
Specified by:
  `remove` in interface `java.util.List`

#### removeAll

    public boolean removeAll(java.util.Collection c)

Specified by:
  `removeAll` in interface `java.util.Collection`
Specified by:
  `removeAll` in interface `java.util.List`

#### retainAll

    public boolean retainAll(java.util.Collection c)

Specified by:
  `retainAll` in interface `java.util.Collection`
Specified by:
  `retainAll` in interface `java.util.List`

#### set

    public java.lang.Object set(int index,
                                java.lang.Object element)

Specified by:
  `set` in interface `java.util.List`

#### size

    public int size()

Specified by:
  `size` in interface `java.util.Collection`
Specified by:
  `size` in interface `java.util.List`

#### subList

    public java.util.List subList(int fromIndex,
                                  int toIndex)

Specified by:
  `subList` in interface `java.util.List`

#### toArray

    public java.lang.Object[] toArray()

Specified by:
  `toArray` in interface `java.util.Collection`
Specified by:
  `toArray` in interface `java.util.List`

#### toArray

    public java.lang.Object[] toArray(java.lang.Object[] a)

Specified by:
  `toArray` in interface `java.util.Collection`
Specified by:
  `toArray` in interface `java.util.List`

#### __tojava__

    public java.lang.Object __tojava__(java.lang.Class c)

Description copied from class: `PyObject`
Equivalent to the Jython __tojava__ method. Tries to coerce this object to an instance of the requested Java class. Returns the special object `Py.NoConversion` if this `PyObject` can not be converted to the desired Java class.

Overrides:
  `__tojava__` in class `PySequence`
Parameters:
  `c` - the Class to convert this `PyObject` to.

#### traverse

    public int traverse(Visitproc visit,
                        java.lang.Object arg)

Description copied from interface: `Traverseproc`
Traverses all directly contained `PyObject`s. Like in CPython, `arg` must be passed unmodified to `visit` as its second parameter. If `Visitproc.visit(PyObject, Object)` returns nonzero, this return value must be returned immediately by traverse. `Visitproc.visit(PyObject, Object)` must not be called with a `null` PyObject-argument.

Specified by:
  `traverse` in interface `Traverseproc`

#### refersDirectlyTo

    public boolean refersDirectlyTo(PyObject ob)

Description copied from interface: `Traverseproc`
Optional operation. Should only be implemented if it is more efficient than calling `Traverseproc.traverse(Visitproc, Object)` with a visitproc that just watches out for `ob`. Must return `false` if `ob` is `null`.

Specified by:
  `refersDirectlyTo` in interface `Traverseproc`